#include "ti86asm.inc"
#include "asm86.h"
#include "ti86math.inc"
;#include "ti86ops.inc"
#include "ti86abs.inc"


;I'm too lazy to document it.."If coding is hard to understand then the code should be hard to understand too"


.org _asm_exec_ram

 		nop			     	
		jp start
 		.dw $0001
		.dw title
		.dw shellcon

;CUSTOM CALLS************

fix:
	call _clrLCD
	call _homeup
	ret
wait:
	call _puts
	call _getkey
	ret
draw:
	call _ILine
	call _getkey
	ret
put:
	call _vputs
	call _getkey
	ret

;PROGRAM STARTS HERE***********

start:	
					;T'is the beginning
	call _flushallmenus
	call _runindicoff
	call fix
	jr main

main:
	call fix
	ld hl, main_menu
	call wait
	cp k1
	jr z, functions_and_graphs
	cp k2
	jr z, limits
	cp k3
	jp z, derivitives
	cp k4
	jp z, integrals
	cp k5
	jp z, theorems
	cp k6
	jp z, information
	cp kExit
	jr z, exit
	jr main

exit:
	call _clrScrn
	call _homeup
	res 5,(iy+0)
	ret
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%functions and graphs
functions_and_graphs:
	call fix
	ld hl, functions_and_graphs_menu
	call wait
	cp k1
	jr z, asymptotes
	cp k2
	jr z, continuity
	cp kExit
	jr z, main
	jr functions_and_graphs

asymptotes:
	call fix
	ld hl, asymptotes_text
	call _puts
	ld b, 4
	ld c, 24
	ld d, 14
	ld e, 24
	ld h, 1
	call _ILine
	call _getkey
	cp kExit
	jr z, functions_and_graphs
	call fix
	ld hl, asymptotes_text2
	call wait
	jr functions_and_graphs

continuity:
	call fix
	ld hl, continuity_text
	call wait
	jr functions_and_graphs

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	LIMITS!!!


limits:
	call fix
	ld hl, limits_menu
	call wait
	cp k1
	jr z, limit1
	cp k2
	jr z, limit2
	cp k3
	jp z, limit3
	cp kExit
	jp z, main
	jr limits

limit1:
	call fix
	ld hl, limit1_text
	call _puts
	ld b, 53
	ld c, 56
	ld d, 80
	ld e, 56
	ld h, 1
	call _ILine
	call _getkey
	cp kExit
	jr z, limits
	call fix
	ld hl, limit1_text2
	call _puts
	ld b, 50
	ld c, 24
	ld d, 77
	ld e, 24
	ld h, 1
	call draw
	jr limits

limit2:
	call fix
	ld hl, limit2_text
	call _puts
	ld b, 90
	ld c, 56
	ld d, 112
	ld e, 56
	ld h, 1
	call _ILine
	ld b, 18
	ld c, 16
	ld d, 45
	ld e, 16
	ld h, 1
	call draw
	cp kExit
	jr z, limits
	call fix
	ld hl, limit2_text2
	call _puts
	ld b, 18
	ld c, 56
	ld d, 55
	ld e, 56
	ld h, 1
	call _ILine
	ld b, 18
	ld c, 24
	ld d, 55
	ld e, 24
	ld h, 1
	call draw
	jp limits


limit3:
	call fix
	ld hl, limit3_text
	call wait
	jp limits

	
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%DERIVITIVES!!!
derivitives:
	call fix
	ld hl, derivitives_menu
	call wait
	cp k1
	jr z, derivitives1
	cp k2
	jr z, derivitives2
	cp k3
	jr z, derivitives3
	cp kExit
	jp z, main
	jr derivitives

derivitives1:
	call fix
	ld hl, derivitives1_text
	call wait
	jr derivitives

derivitives2:
	call fix
	ld hl, derivitives2_text
	call wait
	jr derivitives

derivitives3:
	call fix
	ld hl, derivitives3_text
	call wait
	jr derivitives

;%%%%%%%%%%%%
integrals:
	call fix
	ld hl, integrals_menu
	call wait
	cp k1
	jr z, definite
	cp k2
	jr z, indefinite
	cp k3
	jr z, substitution
	cp kExit
	jp z, main
	jr integrals

definite:
	call fix
	ld hl, definite_text
	call wait
	cp kExit
	jr z,integrals
	jr theorems

indefinite:
	call fix
	ld hl, indefinite_text
	call wait
	jr integrals
	
substitution:
	call fix
	ld hl, substitution_text
	call wait
	jr integrals

;%%%%%%%%%%%%%%%%%%%%%%%%%
;theorems:
;	call fix
;	ld hl, theorems_menu
;	call wait
;	cp k1
;	jr z, theorems1
	;cp kExit
	;jp z, main
	;jr theorems

theorems:
	call fix
	ld hl, theorems1_text
	call _puts
	ld a, 6
	ld (_penCol), a
	ld a, 9
	ld (_penRow), a
	ld hl, theorems1_text2
	call _vputs
	ld a, 1
	ld (_penCol), a
	ld a, 24 
	ld (_penRow), a
	ld hl, theorems1_text3
	call _vputs
	ld a, 0
	ld (_curCol), a
	ld a, 2
	ld (_curRow), a
	ld hl, theorems1_text4
	call _puts
	ld a, 0
	ld (_curCol), a
	ld a, 4
	ld (_curRow), a
	ld hl, theorems1_text5
	call _puts

	ld a, 6
	ld (_penCol), a
	ld a, 42
	ld (_penRow), a
	ld hl, theorems1_text6
	call _vputs
	ld a, 1
	ld (_penCol), a
	ld a, 55
	ld (_penRow), a
	ld hl, theorems1_text8
	call _vputs
	ld a, 0
	ld (_curCol), a
	ld a, 6
	ld (_curRow), a
	ld hl, theorems1_text7
	call wait
	jp main

;%%%%%%%%%%%%
information:
	call fix
	ld hl, info
	call wait
	jp main





title:
 	.db "APCAB by Terrence Wong",0   ;Shell comment 
shellcon:
	.db 8,1
	.db %11111111
	.db %11111111
	.db %00000001
	.db %01001100
	.db %10101010
	.db %11101100
	.db %10101010
	.db %10101100

	
;MENUS**********
main_menu:
	.db "1: Functions & Graphs"
	.db "2: Limits            "
	.db "3: Derivitives       "
	.db "4: Integrals         "
	.db "5: Fundamental       "
	.db "  Theorem of Calculus"
	.db "6: Information",0


functions_and_graphs_menu:
	.db "1: Asymptotes        "
	.db "2: Continuity",0

limits_menu:
	.db "1: Lim x",Lstore,"a number    "
	.db "2: Lim x",Lstore,"infinity    "
	.db "3: Definition",0

derivitives_menu:
	.db "The derivitive is    "
	.db "essentially the slope"
	.db "1: At a point        "
	.db "2: f'(x) and f''(x)  "
	.db "3: Common Derivitives",0

integrals_menu:
	.db "Evaluating           "
	.db "1: Definite          "
	.db "2: Indefinite        "
	.db "3: Substitution      "
	.db Lintegral,"Acceleration        "
	.db "  =Velocity function "
	.db Lintegral,"Velocity function   "
	.db "  =Position function",0



;DATA*************

asymptotes_text:
	.db "As f(x) approaches   "
	.db "infinity, does it go "
	.db "to a number but not  "
	.db "cross it?            "
	.db " x   approaches zero "
	.db " x",Lsquare,"   (horizontal    "
	.db "       asymptote)    "
	.db "       more...",0
asymptotes_text2:
	.db "There is usually a   "
	.db "vertical asymptote   "
	.db "when the denominator "
	.db "is zero.",0
continuity_text:
	.db "f(x) is continuous at"
	.db "a point c when       "
	.db "1. it is defined at c"
	.db "2. Lim f(x) exists   "
	.db "      x",Lstore,"c            "
	.db "3. f(c)=lim f(c)     "
	.db "           x",Lstore,"c ",0

limit1_text:
	.db "lim      f(x)        "
	.db "  x",Lstore,"a    g(x)        "
	.db "                     "
	.db "Evaluate at a if real"
	.db "Use factoring and    "
	.db "other algebra to     "
	.db "reduce so denominator"
	.db "won't be 0. more..",0
limit1_text2:
	.db "If you plug 0 into   "
	.db "the equation and get "
	.db "0/0 then it is       "
	.db "reducible. If so, use"
	.db "lim     f'(x)        "
	.db "   x",Lstore,"a  g'(x)        "
	.db "(L'H",LoCaret,"ptal's rule, a  "
	.db "BC topic)",0
limit2_text:
	.db "lim            f(x)  "
	.db "  x",Lstore,"infinity   g(x)  "
	.db "                     "
	.db "Compare degrees of   "
	.db "leading exponents    "
	.db "1. 4x",Lsquare,"               "
	.db "   6x",Lsquare,"  =Ratio 4/6   "
	.db "          (more...)",0
limit2_text2
	.db "2. 4x^100  Infinity  "
	.db "   6x^5   =or Does   "
	.db "           Not Exist "
	.db "                     "
	.db "3. 4x^5              "
	.db "   6x^100  =Zero",0
limit3_text:
	.db "lim      f(x)-f(a)   "
	.db " x",Lstore,"a    ---------    "
	.db "            x-a      "
	.db " or",Lellipsis,"                 "
	.db "lim    f(x+h)-f(x)   "
	.db " h",Lstore,"0  -----------    "
	.db "          h     ",0

derivitives1_text:
	.db "The derivitive at a  "
	.db "point = Instantaneous"
	.db "Rate of Change there "
	.db "a.k.a. the slope",0
derivitives2_text:
	.db "If           then    "
	.db "f''(x) f'(x) f(x)    "
	.db "---------------------"
	.db "       +++   ",LsqUp,"       "
	.db "       ---   ",LsqDown,"      "
	.db " +++         cc  ",LsqUp,"   "
	.db " ---         cc  ",LsqDown,"    "
	.db "cc=Concavity",0
derivitives3_text:
	.db "sin",Lconvert,"cos  csc",Lconvert,"-csc*cot"    
	.db "cos",Lconvert,"-sin sec",Lconvert,"sec*tan "
	.db "tan",Lconvert,"sec",Lsquare," cot",Lconvert,"-csc",Lsquare,"   "
	.db " tan",Linverse,Lconvert,"1/(1+x",Lsquare,")       "
	.db " sin",Linverse,Lconvert,"1/(",Lroot,"(1+x",Lsquare,"))    "
	.db " ln",Lbar,"x",Lbar,Lconvert,"1/x           "
	.db " 2^x",Lconvert,"2^x*ln2 Remember" 
	.db " e^x",Lconvert,"e^x  chain rule",0

theorems_menu:
	.db "1:Fundamental Theorem",0
theorems1_text:
	.db "Part 1:Derivitive of",0
theorems1_text2:
	.db "x",0
theorems1_text3:
	.db "0",0
theorems1_text4:
	.db Lintegral," t",Lsquare," dt= x",Lsquare,0
theorems1_text5:
	.db "Part 2:Evaluating",0
theorems1_text6:
	.db "5",0
theorems1_text7:
	.db Lintegral," f(x) dx= F(5)-F(0)",0
theorems1_text8:
	.db "0              F(x)=The antideritive of   f(x)",0

definite_text:
	.db "The area under the   "
	.db "curve bounded by the "
	.db "integral. It tells   "
	.db "the sum of all the   "
	.db "changes of the       "
	.db "function before it   "
	.db "(velocity= total     "
	.db "position change)more",0

indefinite_text:
	.db "To solve, take anti- "
	.db "deritive of the      "
	.db "integrand, and add a "
	.db "constant             "
	.db Lintegral,"x=(1/2)x",Lsquare,"+c",0

	
substitution_text:
	.db Lintegral,"x(x",Lsquare,"+1) dx          "
	.db "use u=x",Lsquare,"+1            "
	.db "and so du=2x dx       "
	.db "or 1/2 du=x dx        "
	.db "becomes:              "
	.db Lintegral,".5u du                 "
	.db "Now solve it",0

info:
	.db "AP Calculus AB       "
	.db "v.8.10.19.99         "
	.db "By Terrence Wong     "
	.db "Nothing is my fault. "
	.db "# Keys= Choose Option"
	.db "Exit  = Up One Level "
	.db "Anykey= Continue",0




.end
